my $instances = [
  '&Addable' => [
     'Int = 0 | 1 | -1 | ...',
     'Uint = 0 | 1 | ...',
     'String = "" | "a" | "b" | ...'
  ],
  '&Ordered' => [
     'Int = 0 | 1 | -1 | ...',
     'Uint = 0 | 1 | ...',
     '&Vector(&Ordered)',
  ],

  '&Serializable' => [
     'Int = 0 | 1 | -1 | ...',
     'String = "" | "a" | "b" | ...',
     'Maybe(&Serializable) = None | Some(&Serializable)',
     '&Vector(&Serializable)',
  ],

  '&Mapable' => [
     'Maybe = _->None | Some',
  ],

  '&Iterator' => [
     'Range = t -> None | Inc_range(t,t,Int)',
  ],  

  '&Iterator(Char = "a" | "b" | ...)' => [
     'String = "" | "a" | "b" | ...',
  ],  

  '&Vector(Bool = True | False)' => [
     'PackedBool(String  "" | "a" | "b" | ...)',
  ],

];

my $closing_examples = [
[
 [ '1', '&Addable', 'Uint', 'Int' ],
 [ '1', '&Ordered', 'Uint', 'Int' ],
 [ '1', '&Addable |&| &Strict', 'Uint', 'Int' ],
 [ '1', '&Addable |&| &Ordered', 'Uint', 'Int' ],
],
[
 [ '"foo"', '&Addable', 'String', 'String' ],
 [ '"foo"', '&Ordered', 'error', 'error' ],
 [ '"foo"', '&Addable |&| &Strict', 'String', 'String' ],
 [ '"foo"', '&Addable |&| &Ordered', 'error', 'error' ],
],
[
 [ '1 | "foo"', '&Addable', 'Uint | String', 'Int | String' ],
 [ '1 | "foo"', '&Ordered', 'error', 'error' ],
 [ '1 | "foo"', '&Addable |&| &Strict', 'error', 'error' ],
 [ '1 | "foo"', '&Addable |&| &Ordered', 'error', 'error' ],
],
[
 [ '1 |&| "foo"', '&Addable', 'Uint |&| String', 'Int |&| String' ],
 [ '1 |&| "foo"', '&Ordered', 'Uint', 'Int' ],
 [ '1 |&| "foo"', '&Addable |&| &Strict', 'Uint |&| String', 'Int |&| String' ],
 [ '1 |&| "foo"', '&Addable |&| &Ordered', 'Uint', 'Int' ],
],
];

$\ = "\n";

print <<'EOF';
<html>
  <head>
    <title>Closing the World examples</title>
  </head>
<body>
EOF

print "<table border=1 cellpadding=4>";
print "<tr><th>concrete</th><th>abstract</th><th>lower solution</th><th>greater solution</th></tr>";
foreach (@$closing_examples) {
    foreach (@$_) {
	my ($concrete, $abstract, $lower, $greater) = @$_;
	print "<tr align=center>";
	print "<td><tt>" . html_quote($_) . "</tt></td>" foreach $concrete, $abstract, $lower, $greater;
	print "</tr>";
    }
}
print "</table>";

print "
given
";

print "<table cellpadding=4>";
foreach (group_by2(@$instances)) {
    my ($abstract, $l) = @$_;
    print "<tr>", join('', map { "<td>" . html_quote($_) . "</td>" } $_, "!<", $abstract), "</tr>"foreach @$l;
    print "<tr><td>&nbsp;</td></tr>";
}
print "</table>";

print <<'EOF';
<hr>
<address><a href="mailto:pixel@merd.net">Pixel</a></address>
This document is licensed under <a href="http://www.gnu.org/copyleft/fdl.html">GFDL</a> (GNU Free Documentation License).
<p>Release: $Id: close-the-world.html.pl,v 1.4 2002/05/17 15:22:56 pixel_ Exp $

<p><A HREF="http://www.estat.com/getstats?serial=1400113423"><IMG SRC="http://perso.estat.com/cgi-bin/perso/1400113423?page=merd" BORDER=0></A>
</body>
</html>
EOF

sub group_by2 {
    my @l;
    for (my $i = 0; $i < @_ ; $i += 2) {
	push @l, [ $_[$i], $_[$i+1] ];
    }
    @l;
}
sub html_quote {
    local ($_) = @_;
    s/</&lt;/g;
    s/>/&gt;/g;
    $_;
}
