$all = [

"Design" =>
[
 [
  "Why Yet Another Language" =>

  "Because existing scripting languages do not check anything at compile-time,
and statically typed languages are not expressive enough",
  'Check the <a href="index.html#wyal">WYAL</a>',
 ],

 [ "Why should someone familiar with language XXX switch to merd" =>

  "Why should you switch to merd? if you are happy with XXX, you don't have to (adaptation of a citation of Matz)",

  'Check <a href="merd-vs-others.html">merd vs other languages</a>',
 ],

 [ "Is merd the ultimate programming language" =>

   q(Of course not, no programming language is perfect, a programming language could be described by its various design trade-offs.
<p>Here is a list of <a href="flaws.html">merd's Known Flaws</a>),

 ],

],

"Syntax" =>
[
 [
  "When should I use a <b>method</b> call and when should I use a <b>function</b> call" =>
  "As you like, it's the same",
  'Check the <a href="syntax.html#call">function & method call syntax explaination</a>',
 ],
 [
  "<tt>1+2 * 3</tt> is parsed <tt>(1+2)*3</tt> ?!?? Are you crazy!" =>
  'I call this horizontal layout, check the <a href="choices_syntax.html#horizontal_layout">rational</a>',
 ],
],

"Types" =>
[
 [
   "I don't understand the types, any examples",
   q(See the <a href="types.html">examples of merd's type system</a>),
 ],

],

"Lists" =>
[
 [ "How do you make the difference between a tuple and a list",
  'a tuple is a list',

  '
<ul>
<li>in the value land, everything is a tuple.
<li>"<tt>List(t)</tt>" is the type of all tuples which elements are of type t
<li>the "<tt>[ ... ]</tt>" construct forces a tuple to be seen as a list (upcast)
</ul>
examples:
<pre>
(1, 2) !! (1, 2)
[1, 2] !! List(1 | 2)
(1, 2) !< List(1 | 2)

(1, 2) == [1, 2]  is true


List(1)      is  () | ((1)) | (1, 1) | (1, 1, 1) | ...
List(1 | 2)  is  () | ((1)) | ((2)) | (1, 1) | (1, 2) | (2, 1) | (2, 2) | ...
</pre>
'
 ],
],

"Documentation" =>
[
 [
  "Where is the documentation" =>
  "Not much is done yet",
 ],

 [
  "I want to show merd, is there some presentation",
  'Here is <a href="slides">a small presentation</a> (generated with <a href="http://www.mew.org/mgp/">MagicPoint</a> from this <a href="slides.mgp.m4">file</a>)',
 ],
],

"Implementation" =>
[
 [
  "How fast is merd" =>
  "merd's speed is comparable to Python/Perl/Ruby",

  "To achieve OCaml or C's speed, very good optimisations will be needed, especially for multi-methods.
   But merd is fast enough for most programs.
 ",
 ],

 [
  "Will merd be implemented in merd" =>
  "Not likely", "
   merd's target is not writing compiler. You will be able to write one, but
performance will surely stay far from OCaml's. Once again, performance is not
the main goal of merd
 ",
 ],
],

"Fun" =>
[
 [
  "What's this stupid name" =>
  "How Dare You!",
  'See the <a href="THANKS.html">Thanks</a> page',
 ],

 [
  "What is merd's motto" =>
  'Choose the one you prefer below!
<ul>
<li>bring functional programming to the imperative world
<li>bring functional programming to scripting languages
<li>merd is the avenir of the Universe
<li>with merd, <a href="libraries-need-features.html">your libraries will ruleZ dA wOrlD</a>
</ul>'
 ],
],

];

$\ = "\n";

print <<'EOF';
<html>
  <head>
    <title>merd's FAQ</title>
  </head>
<body text="#f5deb3" link="#f5de83" alink="#b3ae71" vlink="#b3ae71" bgcolor="#2f4f4f">
EOF

print "<h2>Summary</h2>";
print "<ul>";
foreach (group_by2(@$all)) {
    my ($category, $l) = @$_;
    print "<li><a href=\"#$category\">$category</a>";
}
print "</ul>";

foreach (group_by2(@$all)) {
    my ($category, $l) = @$_;
    print "<hr><h2><a name=\"$category\">$category</a></h2>";
    print "<ul>";
    foreach (@$l) {
	my ($question, $short, $long) = @$_;
	print "<li><b>$question?</b>";
	if ($long) {
	    print "<p><small>Short answer:</small> ", html_quote($short);
	    print "<p><small>Long answer:</small> ", html_quote($long);
	} else {
	    print "<p><small>Answer:</small> ", html_quote($short);
	}
	print "<p>";
    }
    print "</ul>";
}


print <<'EOF';
<hr>
<address><a href="mailto:pixel@merd.net">Pixel</a></address>
This document is licensed under <a href="http://www.gnu.org/copyleft/fdl.html">GFDL</a> (GNU Free Documentation License).
<p>Release: $Id: faq.html.pl,v 1.9 2002/05/17 15:22:56 pixel_ Exp $

<p><A HREF="http://www.estat.com/getstats?serial=1400113423"><IMG SRC="http://perso.estat.com/cgi-bin/perso/1400113423?page=merd" BORDER=0></A>

</body>
</html>
EOF



sub group_by2 {
    my @l;
    for (my $i = 0; $i < @_ ; $i += 2) {
	push @l, [ $_[$i], $_[$i+1] ];
    }
    @l;
}
sub html_quote {
    local ($_) = @_;
    s/!</!&lt;/g;
    $_;
}
