open List
open Printf
open Common

let (lines_starts : (string * int list) list ref) = ref []

let pos2line ((file : string),a,b) = 
  let starts = map_index (fun a b -> a,b) (assoc file !lines_starts) in
  let ((offset, line), _) = find (fun (_,(e,_)) -> e > a) (combine starts (tl starts @ [99999, 99999])) in
  file, line, a - offset, b - offset

let add file starts =
  lines_starts := (file, starts) :: !lines_starts


let pos2sfull pos = 
  try
    let (file, line, n1,n2) = pos2line pos in
    sprintf ", file %s, line %d, characters %d-%d" file (line + 1) n1 n2
  with Not_found -> ""

let pos2sfull' pos = 
  try
    let (file, line, n1,n2) = pos2line pos in
    sprintf "File \"%s\", line %d, character %d-%d" file (line + 1) n1 n2
  with Not_found -> ""
